<?php

/**
 * Copyright Souke (2018)
 *
 * contact@souke.fr
 *
 * Ce logiciel est un programme informatique servant à aider les producteurs
 * à distribuer leur production en circuits courts.
 *
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 *
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 *
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 */

namespace domain\Document\Invoice;

use common\helpers\GlobalParam;
use yii\data\ActiveDataProvider;
use yii\data\Sort;

class InvoiceSearch extends Invoice
{
    var $paid = null;
    var $username;

    public function rules()
    {
        return [
            [['paid'], 'safe'],
            [['is_sent'], 'boolean'],
            [['comment', 'address', 'status', 'username', 'date'], 'string'],
            [['name', 'reference', 'username'], 'string', 'max' => 255],
        ];
    }

    public function search($params)
    {
        $invoiceModule = InvoiceModule::getInstance();
        $invoiceRepository = $invoiceModule->getRepository();
        $optionsSearch = $invoiceRepository->getDefaultOptionsSearch();

        $sort = new Sort([
            'attributes' => [
                'status',
                'reference',
                'name',
                'date',
                'username' => [
                    'asc' => ['IF(ISNULL(user_invoice.name_legal_person), user_invoice.lastname, user_invoice.name_legal_person)' => SORT_ASC],
                    'desc' => ['IF(ISNULL(user_invoice.name_legal_person), user_invoice.lastname, user_invoice.name_legal_person)' => SORT_DESC],
                ]
            ],
            'defaultOrder' => [
                'status' => SORT_ASC,
                'reference' => SORT_DESC
            ]
        ]);

        $query = Invoice::find()
            ->with($optionsSearch['with'])
            ->joinWith($optionsSearch['join_with'])
            ->where(['invoice.id_producer' => GlobalParam::getCurrentProducerId()])
            //->orderBy('invoice.status ASC, invoice.reference DESC')
            ->orderBy($sort->orders)
            ->groupBy('invoice.id');

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'sort' => $sort,
            'pagination' => [
                'pageSize' => 20,
            ],
        ]);

        $this->load($params);
        if (!$this->validate()) {
            return $dataProvider;
        }

        $query->andFilterWhere(['like', 'invoice.name', $this->name]);
        $query->andFilterWhere(['like', 'invoice.reference', $this->reference]);
        $query->andFilterWhere(['like', 'invoice.status', $this->status]);
        $query->andFilterWhere([
            'or',
            ['like', 'user_invoice.lastname', $this->username],
            ['like', 'user_invoice.name', $this->username],
            ['like', 'user_invoice.name_legal_person', $this->username],
        ]);

        if ($this->date && strlen($this->date)) {
            $query->andFilterWhere(['like', 'invoice.date', date('Y-m-d', strtotime(str_replace('/', '-', $this->date)))]);
        }

        // filtre envoyé
        if(!is_null($this->is_sent) && is_numeric($this->is_sent)) {
            if($this->is_sent) {
                $query->andWhere(['invoice.is_sent' => 1]);
            }
            else {
                $query->andWhere('invoice.is_sent IS NULL OR invoice.is_sent = 0');
            }
        }

        // filter payé / non payé
        // @TODO : comprendre pourquoi la pagination ne suit pas
        $models = $dataProvider->getModels();
        foreach($models as $index => $invoice) {
            if(!is_null($this->paid) && is_numeric($this->paid)) {
                $isInvoicePaid = $invoiceModule->getSolver()->isInvoicePaid($invoice);
                if(($this->paid && !$isInvoicePaid) || (!$this->paid && $isInvoicePaid)) {
                    unset($models[$index]);
                }
            }
        }
        $dataProvider->setModels($models);

        return $dataProvider;
    }
}
